#!/bin/sh

# TODO: detect term or set it globally
TERM_EMU="kitty"

die() {
    notify-send "$@"
    exit 1
}

check_exists() {
    for c in $@; do
        which "$c" > /dev/null 2>&1 || return 1
    done
}

if ! which wl-paste > /dev/null && [ ! -z "$WAYLAND_DISPLAY" ]; then
    die "Wayland detected and wl-paste not found"
elif ! which xsel > /dev/null && [ -z "$WAYLAND_DISPLAY" ]; then
    die "xsel not found"
fi

if [ -z "$WAYLAND_DISPLAY" ]; then
    clip="$(xsel -b -o)"
else
    clip="$(wl-paste)"
fi

urls="$(echo $clip | grep -o 'https\?://[a-zA-Z0-9~#%&_+=,.?/-]\+')"

# Check the requirements for every option
opts=""
check_exists "$TERM_EMU" "mpv" "youtube-dl" &&
    opts="$(printf "audio-search\n%s" "$opts")"
check_exists "dragon" &&
    opts="$(printf "drag-n-drop\n%s" "$opts")"
# Enable additional features when the clipboard contains an URL
if [ -n "$urls" ] && check_exists "youtube-dl"; then
    check_exists "mpv" &&
        opts="$(printf "play\n%s" "$opts")"
    opts="$(printf "download\n%s" "$opts")"
fi
# Load default choice last
check_exists "qrencode" "feh" &&
    opts="$(printf "qr\n%s" "$opts")"

choice="$(printf "%s" "$opts" | dmenu -p "$(printf "%s" "$clip" | cut -c 1-48)")"
case "$choice" in
    "qr")
        printf "%s" "$clip" | qrencode -o - | feh -. -Z --force-aliasing --geometry 400x400 -
        ;;
    # Download supports optional folder target
    "download"*)
        path="$HOME/mus/$(printf "%s" "$choice" | cut -d " " -f 2-)"
        [ -d "$path" ] || mkdir -p "$path"
        cd "$path" || exit
        youtube-dl -x --audio-format mp3 --no-playlist -o "%(title)s.%(ext)s" "$clip" 2>&1 | grep 'ERROR:' | xargs -n1 -d "\n" notify-send
            #notify-send "Error while downloading: $clip"
        ;;
    "drag-n-drop"*)
        dragon -x "$clip"
        ;;
    "play")
        mpv --ytdl-format='bestvideo[height<=?720]+bestaudio/best' "$clip" 2>&1 | grep 'ERROR:' | xargs -n1 -d "\n" notify-send

        ;;
    "audio-search")
        "$TERM_EMU" --single-instance mpv --ytdl-format=bestaudio ytdl://ytsearch:"$clip"
        ;;
    *)
        printf 'Nope\n'
        ;;
esac